package com.cnooc.edgeapp.config;

/**
 * @Name: MinioConfig
 * @Description:
 * @Version: V1.0.0  （版本号）
 * @Author: cuiliang
 * @Create Date:2021/3/15
 */

import io.minio.MinioClient;
import io.minio.errors.InvalidEndpointException;
import io.minio.errors.InvalidPortException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * minio 核心配置类
 * @Description:
 * @Version: V1.0.0  （版本号）
 * @Author: zhangchengcheng
 */
@Configuration
@EnableConfigurationProperties(MinioProp.class)
public class MinioConfig {

    @Autowired
    private MinioProp minioProp;

    /**
     * 获取 MinioClient
     *
     * @return
     * @throws InvalidPortException
     * @throws InvalidEndpointException
     */
    @Bean
    public MinioClient minioClient() throws InvalidPortException, InvalidEndpointException {
        return new MinioClient(minioProp.getUrl(), minioProp.getAccesskey(), minioProp.getSecretKey());
    }
}
