package com.cnooc.edgeapp.controller;

import com.alibaba.fastjson.JSONObject;
import com.cnooc.edgeapp.entity.PersonnelBraceletAssociation;
import com.cnooc.edgeapp.service.LoginService;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;

/**
 * @program: oo-qhd-sam-agg
 * @description:
 * @author: niujie
 * @create: 2023-07-12 17:09
 */
@RestController
@RequestMapping("/braceletBinding")
public class BraceletBindingPdaController {

    @Value("${url}")
    public String url;

    @Resource(name = "restTemplate1")
    RestTemplate restTemplate;

    @Autowired
    private LoginService loginService;

    /**
     * 手环绑定列表
     */
    @GetMapping("/braceletBindingPage")
    public Object braceletBindingPage(String userName,
                                                  String unit,
                                                  String boardingTime,
                                                  @RequestParam("loginName") String loginName,
                                                  @RequestParam("pageNo") Integer pageNo,
                                                  @RequestParam("pageSize") Integer pageSize) {
        HttpHeaders httpHeaders = loginService.getAuthorization();
        MultiValueMap<String, Object> formdate = new LinkedMultiValueMap<>();
        HttpEntity<MultiValueMap<String, Object>> entity = new HttpEntity<MultiValueMap<String, Object>>(formdate, httpHeaders);
        ResponseEntity<Object> exchange = null;
        try {
            exchange = restTemplate.exchange(url + "braceletBinding/braceletBindingPage?userName="+userName + "&unit=" + unit + "&boardingTime=" + boardingTime + "&loginName=" + loginName + "&pageNo=" + pageNo + "&pageSize=" + pageSize, HttpMethod.GET, entity, Object.class);
        } catch (RestClientException e) {
            String message = e.getMessage();
            message = message.replaceAll("500 Internal Server Error: ", "");
            message = message.substring(1, message.length() - 1);
            JSONObject jsonObject = JSONObject.parseObject(message);
            return jsonObject;
        }
        return exchange;
    }

    /**
     * 保存数据
     * @param
     * @return
     */
    @PostMapping("/saveBraceletNo")
    Object saveBraceletNo(@RequestBody PersonnelBraceletAssociation personnelBraceletAssociation) {
        ObjectMapper mapper = new ObjectMapper();
        try {
            String json = mapper.writeValueAsString(personnelBraceletAssociation);

            HttpHeaders httpHeaders = loginService.getAuthorization();
            httpHeaders.setContentType(MediaType.APPLICATION_JSON);
            HttpEntity<String> entity = new HttpEntity<>(json, httpHeaders);
            ResponseEntity<Object> exchange = restTemplate.exchange(url + "braceletBinding/saveBraceletNo", HttpMethod.POST, entity, Object.class);
            return exchange;
        } catch (JsonProcessingException | RestClientException e) {
            String message = e.getMessage();
            message = message.replaceAll("500 Internal Server Error: ", "");
            message = message.substring(1, message.length() - 1);
            JSONObject jsonObject = JSONObject.parseObject(message);
            return jsonObject;
        }
    }
}
