package com.cnooc.edgeapp.dto;

import lombok.Data;

import java.util.Date;

/**
 * DrillPlan
 *
 * @author mtx
 * @date 2022/10/10 12:54
 */
@Data
public class DrillRecord {

    private String id;
    /**
     * 演习计划id
     */
    private String planId;
    /**
     * 演习签名url
     */
    private String drillSignUrl;
    /**
     * 演习签字人
     */
    private String drillSignName;
    /**
     * 演习签名上传时间
     */
    private Date drillSignTime;
    /**
     * 实际开始时间
     */
    private String realityDate;
    /**
     * 实际开始时间
     */
    private String realityStartTime;
    /**
     * 实际结束时间
     */
    private String realityEndTime;
    /**
     * 未到人员
     */
    private String notParticipatingPerson;
    /**
     * 总人数
     */
    private int personTotal;
    /**
     * 总应到人数
     */
    private int presentNumTotal;
    /**
     * 应到人数1#艇
     */
    private int presentNumOne;
    /**
     * 实到人数1#艇
     */
    private int actuallyArrivedNumOne;
    /**
     * 未到人数1#艇
     */
    private int notArrivedNumOne;
    /**
     * 应到人数2#艇
     */
    private int presentNumTwo;
    /**
     * 实到人数2#艇
     */
    private int actuallyArrivedNumTwo;
    /**
     * 未到人数2#艇
     */
    private int notArrivedNumTwo;
    /**
     * 组织人职务
     */
    private String organizerJob;
    /**
     * 演习总结
     */
    private String drillSummary;
    /**
     * 描述
     */
    private String remarks;
    /**
     * 总监签字图片
     */
    private String signPic;
    /**
     * 总监审核意见
     */
    private String commissionerOpinion;
    /**
     * 启动应急演习人员
     */
    private String started;
    /**
     * 创建人
     */
    private String created;
    /**
     * 创建时间
     */
    private Date createTime;
    /**
     * 修改人
     */
    private String updated;
    /**
     * 修改时间
     */
    private Date updateTime;
    /**
     * 是否删除
     */
    private String isDel;
}
