package com.cnooc.edgeapp.dto;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

import java.util.List;

@Data
public class MassageDto {
    /**
     * 查询指定用户在指定公司下是否拥有指定菜单及其菜单操作的权限
     * @param businessCode 消息发送方业务编号
     * @param businessName 消息发送方业务编号
     * @param topicCode  主题编号
     * @param protocols Items Enum: "stationLetter" "email"
     * @param param 主题关键字(模板变量)
     * @param rangeType 接收人范围类型：STAFF=人员、POSITION=岗位、DEPARTMENT=部门、ROLE=角色
     * @param codes 当指定为STAFF、POSITION、DEPARTMENT、ROLE对应的编码
     * @return
     */
    private String businessCode;
    private String businessName;
    private String topicCode;
    private List<String> protocols;
    private List<Receivers> receivers;
    private JSONObject param;


}