package com.cnooc.edgeapp.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @description: 巡检记录
 * @author: lee
 */
@Data
public class PatrolRecord implements Serializable {


        /**
         * 主键id
         */
        private String id;
        /**
         * 平台号
         */
        private String platCode;

        /**
         * 更新人
         */
        private String updatedBy;
        /**
        /**
         * 更新人
         */
        private String createdBy;
        /**
         * 更新时间
         */
        private Date updatedTime;
        /**
         * 巡检班次时间
         */
        @JsonFormat(shape = JsonFormat.Shape.STRING,pattern = "HH:mm")
        private Date patrolTime;
        /**
         * 巡检具体时间
         */
        private Date patrolRealTime;
        /**
         * 巡检状态;1.未巡检 2.已巡检 3.无法打卡 4.区域隔离5.无法打卡6.其他
         */
        private Integer patrolStatus;
        /**
         * 打卡人
         */
        private String patrolPerson;
        /**
         * 打卡区域
         */
        private String location;

        /**
         * 区域名称
         */
        private String locationName;

        /**
         * 所属甲板
         */
        private String deck;

        /**
         * 甲板名称
         */
        private String deckName;


        /**
         * 其他原因备注
         */
        private String reasonRemarks;
        /**
         * 是否异常
         */
        private Integer isAbnormal;
        /**
         * 甲板排序
         */
        private Integer deckSort;
        /**
         * 区域排序
         */
        private Integer locationSort;
        /**
         * 创建时间
         */
        private Date createdTime;

        private String voiceUrl;

        private String chartUrl;
}