/*
 *
 * Copyright 2021
 * 工技 安全项目组
 * All right reserved
 *
 */

package com.cnooc.edgeapp.enums;

import com.fasterxml.jackson.databind.ObjectMapper;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Name: 安全作业工具类
 * @Description:
 * @Version: V1.0.0  （版本号）
 * @Author: cuiliang
 * @Create Date:2021/1/23
 */
public class SecurityWorkEnums {

    public static ObjectMapper MAPPER = new ObjectMapper();


    public static final String ELECTRICAL_PERMIT = "电气作业";

    public static final String GENERAL_WORK = "通用作业";

    public static final String TEMPORARY_ELECTRICITY = "临时用电";

    public static final String HOT_WORK = "热工作业";

    public static final String WORK_IN_RESTRICTED_SPACE = "进入限制空间作业";

    public static final String WORK_HIGH = "高空作业";

    public static final String LARGE_LIFTING_OPERATION = "大型起重作业";

    public static final String AQUANAUT_WORK = "潜水作业";

    public static final String EXPLOSIVE_RADIATION_HARMFUL_OPERATION = "爆破、放射性、有毒有害作业";

    public static final String TAKE_PRESSURE_HOMEWORK = "带压作业";

    public static final String SIGNAL_BYPASS = "信号旁通";

    public static final String POWER_CUT_OFF = "电力隔离";

    public static final String ISOLATION_LOCK = "隔离锁定";

    public static final Map<String,String> APPLY_ITEMS = new HashMap<String,String>(){{
        this.put("1",ELECTRICAL_PERMIT);
        this.put("2",GENERAL_WORK);
        this.put("3",TEMPORARY_ELECTRICITY);
        this.put("4",HOT_WORK);
        this.put("5",WORK_IN_RESTRICTED_SPACE);
        this.put("6",WORK_HIGH);
        this.put("7",LARGE_LIFTING_OPERATION);
        this.put("8",AQUANAUT_WORK);
        this.put("9",EXPLOSIVE_RADIATION_HARMFUL_OPERATION);
        this.put("10",TAKE_PRESSURE_HOMEWORK);
        this.put("11",SIGNAL_BYPASS);
        this.put("12",POWER_CUT_OFF);
        this.put("13",ISOLATION_LOCK);
    }};

    public static final String IN_THE_LICENSE_TYPE = "审批中";
    public static final String PERMISSION_PASSES_TYPE = "审批通过";
    public static final String REJECT_TYPE = "驳回";
    public static final String CLOSED = "已关闭";

    public static final Map<String,String> APPLY_STATUS = new HashMap<String,String>(){{
        this.put("0",IN_THE_LICENSE_TYPE);
        this.put("1",PERMISSION_PASSES_TYPE);
        this.put("2",REJECT_TYPE);
        this.put("3",CLOSED);
    }};

    public static final String TYPE_BLOW = "防爆";
    public static final String TYPE_FIRE = "防火";
    public static final String TYPE_RUN_INTO = "防碰";
    public static final String TYPE_LCE = "防冰";
    public static final String YH_TYPE = "YH";
    /**
     * 低电量标准
     */
    public static final Integer POWER_STANDARD = 20;

    public static final String POWER_NORMAL = "正常";
    public static final String POWER_LOW = "低电量";


    public static final String CUSTOMIZE_FENCE = "自定义围栏";
    public static final String EMERGENCY_FENCE = "应急围栏";
    public static final String TRENDS_FENCE = "动态围栏";

    public static final String CEPI_PLATFORM_ID = "3F1E5858C6CC41E2BF4FFC4902797C08";
    public static final String CEPJ_PLATFORM_ID = "FA1CF76628104FB383BB444C8861BFCB";

    public static final String EQUIPMENT_AND_FACILITIES = "设备设施";
    public static final String ENVIRONMENTAL = "环境";
    public static final String UNSAFE_BEHAVIOR_OF_PEOPLE = "人的不安全行为";
    public static final String MANAGEMENT_DEFECT_CLASS = "管理缺陷";
    public static final String WELL_CLASS = "井";
    public static final String OTHER_TYPES = "其他";

    public static final String HIDDEN_DANGER = "现场级";
    public static final String PLATFORM_LEVEL_HAZARD = "作业公司级";
    public static final String COMPANY_LEVEL_HIDDEN_TROUBLE = "天津分公司级";

    public static final String CEPI_PLATFORM_NAME = "QHD32-6CEPI";
    public static final String CEPJ_PLATFORM_NAME = "QHD32-6CEPJ";
    public static final String WHPA_PLATFORM_NAME = "QHD32-6WHPA";
    public static final String WHPB_PLATFORM_NAME = "QHD32-6WHPB";
    public static final String WHPC_PLATFORM_NAME = "QHD32-6WHPC";
    public static final String WHPD_PLATFORM_NAME = "QHD32-6WHPD";
    public static final String WHPE_PLATFORM_NAME = "QHD32-6WHPE";
    public static final String WHPF_PLATFORM_NAME = "QHD32-6WHPF";
    public static final String WHPG_PLATFORM_NAME = "QHD32-6WHPG";

    /**
     * 现场级
     */
    public static final String SCENE_TYPE = "Ⅰ级";
    /**
     * 平台级
     */
    public static final String PLAT_TYPE = "Ⅱ级";
    /**
     * 作业公司级
     */
    public static final String COMPANY_TYPE = "Ⅲ级";

    public static final String APPR_MEANING_TYPE = "已批准";
    public static final String WAPPR_MEANING_TYPE = "未审批";
    public static final String CLOSE_MEANING_TYPE = "已关闭";
    public static final String COMP_MEANING_TYPE = "已解决";
    public static final String CAN_MEANING_TYPE = "已取消";
    public static final String DRAFT_MEANING_TYPE = "待提交";

    /**已批准*/
    public static final String APPR_TYPE = "APPR";
    /**未审批*/
    public static final String WAPPR_TYPE = "WAPPR";
    /**已关闭*/
    public static final String CLOSE_TYPE = "CLOSE";
    /**已解决*/
    public static final String COMP_TYPE = "COMP";
    /**已取消*/
    public static final String CAN_TYPE = "CAN";
    /**待提交*/
    public static final String DRAFT_TYPE = "DRAFT";
    /**只查询以下三种状态的隐患*/
    public static final List<String> TYPE_LIST = new ArrayList<String>(){{
        this.add(APPR_TYPE);
        this.add(COMP_TYPE);
        this.add(CLOSE_TYPE);
    }};

    /** 作业单状态 施工中/施工申请审批通过*/
    public static final String CONSTRUCTIONAPPLY_APPR = "1";
    /** 作业单状态 施工关闭审批通过*/
    public static final String CONSTRUCTIONAPPLY_CLOSE = "3";
    /**
     * 低风险
     */
    public static final String LOW_RISK = "#0000FF";
    /**
     * 一般风险
     */
    public static final String GENERAL_RISK = "#FFFF00";
    /**
     * 较大风险
     */
    public static final String LARGER_RISK = "#FF9900";
    /**
     * 重大风险
     */
    public static final String GREAT_RISK = "#FF0033";

    /**
     * 视频报警已查看
     */
    public static final String READINESS_FLAG = "0";

    /**
     * 视频报警误报
     */
    public static final String ELIMINATE_FLAG = "4";

    /**
     * 视频报警状态5
     */
    public static final String ALARM_FIVE = "5";

    /**
     * 首页center无效参数
     */
    public static final String CENTER_FLAG = ":center";
    /**
     * 动态围栏类型
     */
    public static final String TRENDS_FENCE_FLAG = "2";
    /**
     * 已激活围栏
     */
    public static final String FENCE_STATUS = "0";

    /**
     * 手动关闭的围栏
     */
    public static final String FENCE_STATUS_CLOSED = "2";
    /**
     * 开始时间
     */
    public static final String BEGIN_TIME = " 00:00:00";

    /**
     * 结束时间
     */
    public static final String END_TIME = " 23:59:59";

    /**
     * 首页平台无效参数
     */
    public static final String PLAT_FLAG = ":plat_id";
    /**紧急报警*/
    public static List<String> EMERGENCY_ALARM_CODE = new ArrayList<String>() {{
        //紧急报警
        this.add("6");
    }};
    /**健康异常*/
    public static List<String> ABNORMAL_HEALTH_CODE = new ArrayList<String>() {{
        //心率报警
        this.add("24");
        //血压收缩压
        this.add("27");
        //血压舒张压
        this.add("28");
    }};
    /**违规操作*/
    public static List<String> VIOLATION_OPERATION_CODE = new ArrayList<String>() {{
        //安全带
        this.add("未配带安全带");
        //护目镜
        this.add("护目镜识别");
        //头盔
        this.add("安全帽识别");
        //工服
        this.add("工服识别");
    }};
    /**
     * 视频报警类型
     */
    public static String VIDEO_ALARM = "7";
    public static String VIDEO_ALARM_NAME = "井口大盖未归位识别";
    /**
     * 心率报警代码
     */
    public static String HEART_RATE_TYPE = "24";
    /**
     * 血压收缩压报警代码
     */
    public static String SYSTOLIC_PRESSURE_TYPE = "27";
    /**
     * 血压舒张压报警代码
     */
    public static String DIASTOLIC_PRESSURE_TYPE = "28";
    /**
     * SOS报警类型代码
     */
    public static String SOS_ALARM_TYPE = "6";
    /**
     * 高风险标识
     */
    public static String HIGH_RISK_FLAG = "1";

    /**
     * 返回成功代码
     */
    public static final String SUCCEED_CODE = "200";

    public static final String FAIL_TYPE = "未处理";
    public static final String SUCCESS_TYPE = "已处理";


    public static final String DATA_OVER_VIEW_KEY = "dataOverview";

    public static final String TODAY_WORK_KEY = "todayWork";

    public static final String ALL_FIELDS = "QHD32-6";
    public static final String CEPI_CODE = "CEPI";
    public static final String CEPJ_CODE = "CEPJ";
    public static final String FPSO_CODE = "FPSO";
    /**
     * CEPI管理中心 平台名称
     */
    public static List<String> CEPI_NAME = new ArrayList<String>() {{
        this.add("QHD32-6WHPB");
        this.add("QHD32-6WHPG");
        this.add("QHD32-6WHPC");
        this.add("QHD32-6WHPH");
        this.add("QHD32-6CEPI");
    }};
    /**
     * CEPJ管理中心 平台名称
     */
    public static List<String> CEPJ_NAME = new ArrayList<String>() {{
        this.add("QHD32-6CEPJ");
        this.add("QHD32-6WHPE");
    }};
    /**
     * FPSO管理中心 平台名称
     */
    public static List<String> FPSO_NAME = new ArrayList<String>() {{
        this.add("QHD32-6WHPA");
        this.add("QHD32-6WHPD");
        this.add("QHD32-6WHPF");
        this.add("QHD32-6FPSO");
    }};
    /**
     * 硫化氢和其他集合区
     */
    public static final String ROLL_CALL_AREA = "生活区应急集合区";
    public static final String ROLL_CALL_AREA_2 = "生活区二楼";
    public static final String ROLL_CALL_AREA_3 = "生活区三楼";
    public static final String ROLL_CALL_AREA_4 = "生活区四楼";
    public static final String ROLL_CALL_AREA_5 = "生活区五楼";
    /**
     * 一号救生艇
     */
    public static final String ONE_BOAT_FLAG="一号救生艇";
    /**
     * 二号救生艇
     */
    public static final String TWO_BOAT_FLAG="二号救生艇";
    /**
     * 一号救生筏
     */
    public static final String ONE_FLOAT_FLAG = "一号救生筏";
    /**
     * 二号救生筏
     */
    public static final String TWO_FLOAT_FLAG = "二号救生筏";
    /**
     * 三号救生筏
     */
    public static final String THREE_FLOAT_FLAG = "三号救生筏";
    /**
     * 四号救生筏
     */
    public static final String FOUR_FLOAT_FLAG = "四号救生筏";
    /**
     * 五号救生筏
     */
    public static final String FIVE_FLOAT_FLAG = "五号救生筏";
    /**
     * 六号救生筏
     */
    public static final String SIX_FLOAT_FLAG = "六号救生筏";

    /**
     * 1-4号救生筏集合区域
     */
    public static final String MIDDLE_LEVEL_AREA = "中层甲板救生筏应急集合区";

    /**
     * 5-6号救生筏集合区域
     */
    public static final String LOWER_LEVEL_AREA = "下层甲板救生筏应急集合区";

    /**
     * 应急点名
     */
    public static final String EMERGENCY_ROLL_CALL = "应急点名";
    public static final String LIFE_BOAT_CODE = "弃平台应急点名";
    public static final String ELSE_FLOAT_CODE = "其他应急点名";
    public static final String SULFURETTED_HYDROGEN = "硫化氢应急点名";
    /**
     * 开启应急点名标识
     */
    public static final String OPEN_ROLL_CALL = "1";
    /**
     * 关闭应急点名标识
     */
    public static final String CLOSE_ROLL_CALL = "0";
    /**
     * 弃平台点名通知
     */
    public static final String ABANDON_PLATFORM_NOTICE = "平台正在进行弃平台点名  请前往应急集合点集合";
    /**
     * 硫化氢点名通知
     */
    public static final String HYDROGEN_SULFIDE_NOTICE = "平台正在进行硫化氢点名  请前往应急集合点集合";

    /**
     * 其他点名通知
     */
    public static final String ELSE_NOTICE = "平台正在进行其他点名  请前往应急集合点集合";

    /**
     * 结束点名通知
     */
    public static final String CLOSING_ROLL_CALL = "点名结束，请返回工作岗位";

    /**
     * 进入区域
     */
    public static final String IN_FLAG = "0";
    /**
     * 离开区域
     */
    public static final String OUT_FLAG = "1";

    public static final String EQUIPMENT_TYPE = "设备设施类";
    public static final String ENVIRONMENT_TYPE = "环境类";
    public static final String PEOPLE_NOT_SAFE_TYPE = "人的不安全行为";
    public static final String MANAGEMENT_DEFECTS_TYPE = "管理缺陷类";
    public static final String WELL_TYPE = "井类";
    public static final String OTHERS_TYPE = "其他";
    public static final String META = "meta";
    public static final String STATUS = "status";
    public static final String TOTAL = "total";
    public static final String STATUS_CAPITALIZE = "STATUS";
    public static final String DATA = "data";
    public static final String ROWS = "rows";
    public static final String MSG = "msg";
    public static final String TYPE = "type";
    public static final String RISKLEVEL = "riskLevel";
    public static final String APPLYITEM = "applyItem";
    public static final Integer ZERO = 0;
    public static final Integer ONE = 1;
    public static final Integer TWO = 2;
    public static final Integer THREE = 3;
    public static final Integer FOUR = 4;
    public static final Integer FIVE = 5;
    public static final Integer SIX = 6;
    public static final Integer SEVEN = 7;
    public static final Integer EIGHT = 8;
    public static final Integer NINE = 9;
    public static final Integer TEN = 10;
    public static final Integer ELEVEN = 11;
    public static final Integer TWELVE = 12;
    public static final Integer THIRTEEN = 13;
    public static final Integer FIFTY_EIGHT = 58;
    public static final String COMMA = ",";
    public static final String A = "A";
    public static final String B = "B";
    public static final String C = "C";
    public static final String D = "D";
    public static final String E = "E";
    public static final String F = "F";
    public static final String UNDERLINE = "_";
    public static final String GENERAL = "General";
    public static final String H_MM = "h:mm";
    public static final String XLS = "^.+\\.(?i)(xls)$";
    public static final String XLSX = "^.+\\.(?i)(xlsx)$";

    /**
     * 岗位
     */
    public static final String POST_CODE = "postCode";
    public static final String POST_NAME = "postName";

    /**
     * 巡检类型
     */
    public static final Map<Integer,String> PLANTYPES = new HashMap<Integer,String>(){{
        this.put(1,"冬季十防");
        this.put(2,"夏季十防");
    }};

    /**
     * 部分高风险作业类型不展示
     */
    public static final Map<Integer,String> removeHighRiskTYPES = new HashMap<Integer,String>(){{
        this.put(11,"信号旁通");
        this.put(12,"电力隔离");
        this.put(13,"隔离锁定");
    }};

    /**
     * SOS报警是否处理
     */
    public static final List<String> IS_PROCESS = new ArrayList<String>(){{
        this.add("未处理");
        this.add("已处理");
    }};

    /**
     * 台账类别
     */
    public static final List<String> ACCOUNT_TYPES = new ArrayList<String>(){{
        this.add("救生设备");
        this.add("消防设备");
        this.add("劳动防护");
        this.add("监测设备");
        this.add("其他");
    }};

    /**
     * SOS报警是否处理
     */
    public static final Map<String,String> ALARM_STATUS = new HashMap(){{
        this.put("0","未处理");
        this.put("1","已处理");
    }};

    /**违规操作*/
    public static List<String> FILE_TYPES = new ArrayList<String>() {{
        this.add(".bmp");
        this.add(".gif");
        this.add(".pipeg");
        this.add(".jpeg");
        this.add(".jpg");
        this.add(".png");
        this.add(".x-icon");
        this.add(".xlsx");
        this.add(".xls");
        this.add(".pdf");
        this.add(".msword");
        this.add(".visio");
        this.add(".powerpoint");
        this.add(".doc");
        this.add(".docx");
        this.add(".swf");
        this.add(".zip");
        this.add(".rar");
        this.add(".ppt");
        this.add(".pptx");
        this.add(".iso");
        this.add(".html");
        this.add(".exe");
        this.add(".rm");
        this.add(".tmp");
        this.add(".mdf");
        this.add(".mid");
        this.add(".mov");
        this.add(".qt");
        this.add(".asf");
        this.add(".txt");
        this.add(".mp3");
    }};


}
