package com.cnooc.edgeapp.service.impl;

import cn.hutool.core.net.URLEncodeUtil;
import cn.hutool.http.Method;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.auth0.jwt.JWT;
import com.auth0.jwt.interfaces.Claim;
import com.auth0.jwt.interfaces.DecodedJWT;
import com.bluetron.eco.sdk.api.SuposApi;
import com.bluetron.eco.sdk.api.SuposApiEntity;
import com.bluetron.eco.sdk.api.SuposApiEnum;
import com.bluetron.eco.sdk.dto.common.ApiResponse;
import com.bluetron.eco.sdk.dto.common.SuposConfig;
import com.cnooc.edgeapp.domain.R;
import com.cnooc.edgeapp.dto.MassageDto;
import com.cnooc.edgeapp.dto.Receivers;
import com.cnooc.edgeapp.service.LoginService;
import com.google.api.client.repackaged.com.google.common.base.Splitter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.util.StringUtils;
import org.springframework.web.client.RestTemplate;

import javax.annotation.Resource;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.UUID;

@Slf4j
@Service
@ComponentScan
public class LoginServiceImpl implements LoginService {

    @Value("${app.logout}")
    private String logout;
    @Value("${app.white-list}")
    private String whiteList;
    @Value("${app.id}")
    private String appId;
    @Value("${app.deploy}")
    private Boolean deploy;
    @Value("${client_base64}")
    private String Authorization;
    @Value("${client_URL}")
    private String client_URL;
    @Value("${app.url}")
    private String APP_URL;
    @Resource(name = "restTemplate1")
    private RestTemplate restTemplate;
    private final Integer SUSSES = 200;
    private final Integer ERROR = 200;

    @Override
    public HttpHeaders getAuthorization() {
        String url = client_URL + "auth/oauth/token?grant_type=client_credentials&tenant_role_key=QHD32-6";
        HttpHeaders headers = new HttpHeaders();
        headers.set("Authorization", Authorization);
        MultiValueMap<String, Object> form = new LinkedMultiValueMap<>();
        HttpEntity<MultiValueMap<String, Object>> httpEntity = new HttpEntity<MultiValueMap<String, Object>>(form, headers);
        Map map = restTemplate.postForObject(url, httpEntity, Map.class);
        log.info("云端返回实体{}", map.toString());
        HttpHeaders httpHeaders = new HttpHeaders();
        httpHeaders.add("Authorization", "Bearer " + map.get("access_token"));
        httpHeaders.add("App-Id", "2c0f822c569641d7bd13210dce149af4");
        httpHeaders.add("tenant_role_key", "QHD32-6");

        return httpHeaders;
    }

    @Override
    public R loginVerify(String username, HttpServletRequest request, HttpServletResponse response) throws IOException {
        R res = new R();
        log.info(request.getRequestURL().toString());
        //从url中获取授权码参数
        String code = request.getParameter("code");
        log.info("code:{}", code);
        HttpSession session = request.getSession();
        JSONObject object = new JSONObject();
        object.set("key", session.getId());
//        Object object1 = requestUrl(client_URL + "redis/hasKey", object, HttpMethod.GET);
//        if ((Boolean) object1) {
//            res.setCode(SUSSES);
//            res.setMsg(null);
//            res.setData(requestUrl(client_URL + "redis/getDate", object, HttpMethod.GET));
//            log.info("接口请求结束返回实体{}", res);
//            return res;
//        }
        //如果授权码参数为空
        if (!StringUtils.hasText(code)) {
            log.info("授权码为空。。。。。。。---------================》》》》》》》》》》》》》》");
            //302跳转到supOS 获取授权码
            String location = SuposApi.authService.authorize(URLEncodeUtil.encodeAll(buildRedirectUrl(request)), "1");
            log.info("回调之前用get请求回调链接{}",location);
            response.sendRedirect(location);
            log.info("手动重定向完成");
//            response.addHeader("Location", location);
//            response.setStatus(HttpStatus.FOUND.value());
            // 获取云端token
            String url = client_URL + "auth/oauth/token?grant_type=client_credentials";
            HttpHeaders headers = new HttpHeaders();
            headers.set("Authorization", Authorization);
            MultiValueMap<String, Object> form = new LinkedMultiValueMap<>();
            HttpEntity<MultiValueMap<String, Object>> httpEntity = new HttpEntity<MultiValueMap<String, Object>>(form, headers);
            Map map = restTemplate.postForObject(url, httpEntity, Map.class);
            log.info("云端返回实体{}", map.toString());
            res.setCode(SUSSES);
            res.setMsg(null);
            Map<String, Object> msg = new HashMap<>();
            msg.put("token", "Bearer " + map.get("access_token"));
            res.setData(msg);
            res.setCode(SUSSES);
            res.setMsg("授权码为空，获取用户信息失败");
//            redisUtil.set(session.getId(), msg);
            return res;
        } else {
            log.info("授权码换token。。。。。。。");
            //授权码不为空，则用授权码换取token 完成授权
            String id = UUID.randomUUID().toString();
            ApiResponse apiResponse = SuposApi.authService.accessToken(code, logout + "?code=" + id);
            if (apiResponse.getHttpCode().equals(SUSSES)) {
                JSONObject result = JSONUtil.parseObj(apiResponse.getResponseBody());
                //登录用户名
                String usernameLine = result.getStr("username");
                log.info("username:{}", usernameLine);
                //关联的人员编码
                String personCode = result.getStr("personCode");
                log.info("personCode:{}", personCode);
                //人员所属公司编码
                String companyCode = result.getStr("companyCode");
                log.info("companyCode:{}", companyCode);
                String accessToken = result.getStr("accessToken");
                log.info("accessToken:{}", accessToken);
                String refreshToken = result.getStr("refreshToken");
                log.info("refreshToken:{}", refreshToken);
                //TODO 将supOS用户与应用用户关联
                //TODO 应用自身的权限业务,此处相当于应用原来的登录成功后操作
                //TODO 应用原先的登录后处理逻辑

                session.setMaxInactiveInterval(1500);
                session.setAttribute(id, result);
                Cookie authorizeCookie = new Cookie("authorize", id);
                authorizeCookie.setPath("/");
                response.addCookie(authorizeCookie);
                // 获取云端token
                String url = client_URL + "auth/oauth/token?grant_type=client_credentials";
                HttpHeaders headers = new HttpHeaders();
                headers.set("Authorization", Authorization);
                MultiValueMap<String, Object> form = new LinkedMultiValueMap<>();
                HttpEntity<MultiValueMap<String, Object>> httpEntity = new HttpEntity<MultiValueMap<String, Object>>(form, headers);
                JSONObject map = restTemplate.postForObject(url, httpEntity, JSONObject.class);
                log.info("云端返回实体{}", map);
                res.setCode(SUSSES);
                res.setMsg(null);
                JSONObject user = getUser(accessToken);
                assert map != null;
                user.set("token", "Bearer " + map.get("access_token"));
                user.set("code", code);
                user.set("key", session.getId());
                res.setData(user);
                // 存redis
                requestUrl(client_URL + "redis/set", user, HttpMethod.POST, "Bearer " + map.get("access_token"));
                log.info("接口请求结束返回实体{}", res);
                return res;
            } else {
                log.info("授权码失效。。。。。。。");
                //获取token失败，则删除请求url中旧的code及state后重新获取授权码
                String location = SuposApi.authService.authorize(URLEncodeUtil.encodeAll(removeParam(buildRedirectUrl(request), Arrays.asList("code", "state"))), "1");
                response.addHeader("Location", location);
                response.setStatus(HttpStatus.FOUND.value());
                res.setCode(ERROR);
                res.setMsg("授权码失效");
                return res;
            }
        }
    }

    public JSONObject getUser(String token) {
        log.info("获取到token 开始解析 token为：{}", token);
        DecodedJWT jwt = JWT.decode(token);
        Map<String, Claim> claims = jwt.getClaims();
        JSONObject map = new JSONObject();
        for (Map.Entry<String, Claim> entry : claims.entrySet()) {
            map.put(entry.getKey(), jwt.getClaim(entry.getKey()).asString());
        }
        log.info("获取到token 解析完成 解析之后的token为：{}", map);
        return map;
    }
    public Object requestUrl(String url, JSONObject jsonObject, HttpMethod method) {
        log.info("请求云端接口开始");
        // 获取云端token
        String token = null;
        String token_url = "http://10.77.79.57:8080/auth/oauth/token?grant_type=client_credentials";
        HttpHeaders headers = new HttpHeaders();
        headers.set("Authorization", Authorization);
        MultiValueMap<String, Object> form = new LinkedMultiValueMap<>();
        HttpEntity<MultiValueMap<String, Object>> httpEntity = new HttpEntity<MultiValueMap<String, Object>>(form, headers);
        JSONObject map = restTemplate.postForObject(token_url, httpEntity, JSONObject.class);
        assert map != null;
        token = "Bearer " + map.get("access_token");
        log.info("获取云端接口token成功");
        {
            log.info("请求参数为------------》》》》》》》》》{}", jsonObject);
            HttpHeaders headersc = new HttpHeaders();
            headersc.set("Authorization", token);
            if (method.equals(HttpMethod.GET)) {
                log.info("请求参数为------------》》》》》》》》》这是个get请求");
                HttpEntity<MultiValueMap<String, Object>> entity = new HttpEntity<MultiValueMap<String, Object>>(headersc);
                StringBuilder stringBuilder = new StringBuilder("?");
                String substring = null;
                if (jsonObject != null) {
                    for (Map.Entry<String, Object> stringObjectEntry : jsonObject.entrySet()) {
                        stringBuilder.append(stringObjectEntry.getKey()).append("=").append(stringObjectEntry.getValue()).append("&");
                    }
                    substring = stringBuilder.toString().substring(0, stringBuilder.toString().length() - 1);
                }
                ResponseEntity<Object> exchange = restTemplate.exchange(url + substring, HttpMethod.GET, entity, Object.class);
                log.info("请求云端接口结束》》》》》》》》》》》》》》》返回参数{}", exchange.getBody());
                return exchange.getBody();

            } else {
                log.info("请求参数为------------》》》》》》》》》这是个post请求");
                headersc.setContentType(MediaType.APPLICATION_JSON);
                HttpEntity<String> entity = new HttpEntity<>(jsonObject.toString(), headersc);
                ResponseEntity<Object> exchange = restTemplate.exchange(url, HttpMethod.POST, entity, Object.class);
                log.info("请求云端接口结束》》》》》》》》》》》》》》》返回参数{}", exchange.getBody());
                return exchange.getBody();
            }

        }

    }

    public JSONObject requestUrl(String url, JSONObject jsonObject, HttpMethod method, String token) {
        // 获取云端token
        log.info("请求云端接口开始------------有token传入");
        HttpHeaders headersc = new HttpHeaders();
        headersc.set("Authorization", token);
        log.info("请求参数为------------》》》》》》》》》{}", jsonObject);
        if (method.equals(HttpMethod.GET)) {
            log.info("请求参数为------------》》》》》》》》》这是个get请求");
            HttpEntity<MultiValueMap<String, Object>> entity = new HttpEntity<MultiValueMap<String, Object>>(headersc);
            ResponseEntity<JSONObject> exchange = restTemplate.exchange(url, HttpMethod.GET, entity, JSONObject.class);
            log.info("请求云端接口结束》》》》》》》》》》》》》》》参数为{}", exchange.getBody());
            return exchange.getBody();
        } else {
            log.info("请求参数为------------》》》》》》》》》这是个post请求");
            headersc.setContentType(MediaType.APPLICATION_JSON);
            HttpEntity<String> entity = new HttpEntity<>(jsonObject.toString(), headersc);
            ResponseEntity<JSONObject> exchange = restTemplate.exchange(url, HttpMethod.POST, entity, JSONObject.class);
            log.info("请求云端接口结束》》》》》》》》》》》》》》》参数为{}", exchange.getBody());
            return exchange.getBody();
        }


    }

    @Override
    public Object getUserOfMenus(String username, String companyCode) {
        HttpHeaders headers = new HttpHeaders();
        headers.set("Authorization", Authorization);
        JSONObject object = new JSONObject();
        object.set("companyCode", companyCode);
        SuposApiEntity suposApiEntity = new SuposApiEntity("/open-api/rbac/v2/users/" + username + "/permissions/menus", Method.GET);
        ApiResponse apiResponse = SuposApi.doRequest(suposApiEntity, object.toString(), headers);
        log.info("返回JSON：{}", apiResponse);
        return JSON.parseObject(apiResponse.getResponseBody());
    }

    @Override
    public Object getUserOfMenusAndOperate(String username, String companyCode, String menuCode) {
        //http://{domain}:{port}{basePath}/v2/users/{username}/permissions/menus/{menuCode}/operations
        HttpHeaders headers = new HttpHeaders();
        headers.set("Authorization", Authorization);
        JSONObject object = new JSONObject();
        object.set("companyCode", companyCode);
        SuposApiEntity suposApiEntity = new SuposApiEntity("/open-api/rbac/v2/users/" + username + "/permissions/menus/" + menuCode + "/operations", Method.GET);
        ApiResponse apiResponse = SuposApi.doRequest(suposApiEntity, object.toString(), headers);
        log.info("返回JSON：{}", apiResponse);
        return JSON.parseObject(apiResponse.getResponseBody());
    }

    @Override
    public Object sendMessage(String businessCode
            , String businessName
            , String rangeType
            , String codes
            , String protocol
            , String contentStr
            , String text
    ) {
        JSONObject object = new JSONObject();
        object.set("businessCode", businessCode);
        object.set("businessName", businessName);
        JSONObject receivers = new JSONObject();
        List<JSONObject> receiverList = new ArrayList<>();
        receivers.set("rangeType", rangeType);
        receivers.set("codes", Splitter.on(",").trimResults().splitToList(codes));
        receiverList.add(receivers);
        object.set("receivers", receiverList);
        List<JSONObject> contents = new ArrayList<>();

        if (text.contains(";")) {
            List<String> textOne = Splitter.on(";").trimResults().splitToList(text);
            textOne.forEach((String x) -> {
                JSONObject content = new JSONObject();
                List<String> strings = Splitter.on(",").trimResults().splitToList(x);
                JSONObject contentObj = new JSONObject();
                contentObj.set("subject", strings.get(0));
                contentObj.set("text", strings.get(1));
                String string = contentObj.toString();
                content.set("content", string);
                content.set("protocol", protocol);
                contents.add(content);
            });
        } else {
            JSONObject content = new JSONObject();
            List<String> strings = Splitter.on(",").trimResults().splitToList(text);
            content.set("protocol", protocol);
            JSONObject contentObj = new JSONObject();
            contentObj.set("subject", strings.get(0));
            contentObj.set("text", strings.get(1));
            content.set("content", contentObj.toString());
            contents.add(content);
        }
        object.set("contents", contents);
        log.info("消息入参：{}", object);
        ApiResponse apiResponse = SuposApi.doRequest(SuposApiEnum.NOTIFICATION_SEND_MESSAGE, object.toString(), null);
        log.info("返回参数：{}", apiResponse.getResponseBody());
        return apiResponse.getResponseBody();
    }

    @Override
    public Object sendTopicMessage(MassageDto dto) {
        List<Receivers> receivers = dto.getReceivers();
        for (Receivers receiver : receivers) {
            List<String> codeList = new ArrayList<>();
            List<String> codes = receiver.getCodes();
            for (String code : codes) {
                ApiResponse apiResponse = SuposApi.doRequest(SuposApiEnum.USER_DETAIL, null, code);
                log.info("返回参数：{}", apiResponse.getResponseBody());
                com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(apiResponse.getResponseBody());
                codeList.add((String) jsonObject.get("personCode"));
            }
            receiver.setCodes(codeList);
        }


        Object json = JSON.toJSON(dto);
        log.info("消息入参：{}", json);
        ApiResponse apiResponse = SuposApi.doRequest(SuposApiEnum.NOTIFICATION_SEND_MESSAGE_BY_TOPIC, json.toString(), null);
        log.info("返回参数：{}", apiResponse.getResponseBody());
        return apiResponse.getResponseBody();
    }

    @Override
    public Object outLogin(HttpServletRequest request, HttpServletResponse response) {
        return null;
    }

    @Override
    public Object getUserNubmer(String userName) {
        log.info("消息入参：{}", userName);
        ApiResponse apiResponse = SuposApi.doRequest(SuposApiEnum.USER_DETAIL, null, userName);
        log.info("返回参数：{}", apiResponse.getResponseBody());
        com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(apiResponse.getResponseBody());
        return jsonObject;
    }

    private Cookie getCookieByName(HttpServletRequest request, String name) {
        Cookie[] cookies = request.getCookies();
        if (!Objects.isNull(cookies) && cookies.length > 0) {
            Optional<Cookie> optional = Arrays.stream(cookies).filter(x -> x.getName().equals(name)).findAny();
            if (optional.isPresent()) {
                return optional.get();
            }
        }
        return null;
    }

    private static String removeParam(String url, List<String> name) {
        for (String s : name) {
            // 使用replaceAll正则替换,replace不支持正则
            url = url.replaceAll("&?" + s + "=[^&]*", "");
        }
        if (url.endsWith("?")) {
            url = url.substring(0, url.length() - 1);
        }
        return url;
    }

    private String buildRedirectUrl(HttpServletRequest request) {
        StringBuffer redirect = new StringBuffer();
        String queryString = request.getQueryString();
        //如果部署到supOS
        if (deploy) {
            redirect.append(SuposConfig.getSuposApiAddress()).append("/apps/").append(appId).append(request.getRequestURI());
        } else {
            //本地调试
            redirect.append(request.getRequestURL());
        }
        if (StringUtils.hasText(queryString)) {
            redirect.append("?").append(queryString);
        }
        return redirect.toString();
    }
}
